Wireshark 2.9.0-477-g68ec514b The Wireshark network protocol analyzer

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Friends | List of all members
QCPLayout Class Referenceabstract

The abstract base class for layouts. More...

Inheritance diagram for QCPLayout:

## Public Member Functions
| QCPLayout ()
virtual void | update (UpdatePhase phase)
virtual QList< QCPLayoutElement * > | elements (bool recursive) const
virtual int | elementCount () const =0
virtual QCPLayoutElement * | elementAt (int index) const =0
virtual QCPLayoutElement * | takeAt (int index)=0
virtual bool | take (QCPLayoutElement *element)=0
virtual void | simplify ()
bool | removeAt (int index)
bool | remove (QCPLayoutElement *element)
void | clear ()
Public Member Functions inherited from QCPLayoutElement
| QCPLayoutElement (QCustomPlot *parentPlot=0)
QCPLayout * | layout () const
QRect | rect () const
QRect | outerRect () const
QMargins | margins () const
QMargins | minimumMargins () const
QCP::MarginSides | autoMargins () const
QSize | minimumSize () const
QSize | maximumSize () const
QCPMarginGroup * | marginGroup (QCP::MarginSide side) const
QHash< QCP::MarginSide, QCPMarginGroup * > | marginGroups () const
void | setOuterRect (const QRect &rect)
void | setMargins (const QMargins &margins)
void | setMinimumMargins (const QMargins &margins)
void | setAutoMargins (QCP::MarginSides sides)
void | setMinimumSize (const QSize &size)
void | setMinimumSize (int width, int height)
void | setMaximumSize (const QSize &size)
void | setMaximumSize (int width, int height)
void | setMarginGroup (QCP::MarginSides sides, QCPMarginGroup *group)
virtual QSize | minimumSizeHint () const
virtual QSize | maximumSizeHint () const
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
Public Member Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Protected Member Functions
virtual void | updateLayout ()
void | sizeConstraintsChanged () const
void | adoptElement (QCPLayoutElement *el)
void | releaseElement (QCPLayoutElement *el)
QVector< int > | getSectionSizes (QVector< int > maxSizes, QVector< int > minSizes, QVector< double > stretchFactors, int totalSize) const
Protected Member Functions inherited from QCPLayoutElement
virtual int | calculateAutoMargin (QCP::MarginSide side)
virtual void | mousePressEvent (QMouseEvent *)
virtual void | mouseMoveEvent (QMouseEvent *)
virtual void | mouseReleaseEvent (QMouseEvent *)
virtual void | mouseDoubleClickEvent (QMouseEvent *)
virtual void | wheelEvent (QWheelEvent *)
virtual void | applyDefaultAntialiasingHint (QCPPainter *) const
virtual void | draw (QCPPainter *)
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
Protected Member Functions inherited from QCPLayerable
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Friends
class | QCPLayoutElement

## Additional Inherited Members
Public Types inherited from QCPLayoutElement
enum | UpdatePhase { upPreparation, upMargins, upLayout }
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)
Protected Attributes inherited from QCPLayoutElement
QCPLayout * | mParentLayout
QSize | mMinimumSize
QSize | mMaximumSize
QRect | mRect
QRect | mOuterRect
QMargins | mMargins
QMargins | mMinimumMargins
QCP::MarginSides | mAutoMargins
QHash< QCP::MarginSide, QCPMarginGroup * > | mMarginGroups
Protected Attributes inherited from QCPLayerable
bool | mVisible
QCustomPlot * | mParentPlot
QPointer< QCPLayerable > | mParentLayerable
QCPLayer * | mLayer
bool | mAntialiased

## Detailed Description

The abstract base class for layouts.

This is an abstract base class for layout elements whose main purpose is to define the position and size of other child layout elements. In most cases, layouts don't draw anything themselves (but there are exceptions to this, e.g. QCPLegend).

QCPLayout derives from QCPLayoutElement, and thus can itself be nested in other layouts.

QCPLayout introduces a common interface for accessing and manipulating the child elements. Those functions are most notably elementCount, elementAt, takeAt, take, simplify, removeAt, remove and clear. Individual subclasses may add more functions to this interface which are more specialized to the form of the layout. For example, QCPLayoutGrid adds functions that take row and column indices to access cells of the layout grid more conveniently.

Since this is an abstract base class, you can't instantiate it directly. Rather use one of its subclasses like QCPLayoutGrid or QCPLayoutInset.

For a general introduction to the layout system, see the dedicated documentation page The Layout System.

## Constructor & Destructor Documentation

QCPLayout::QCPLayout | ( |  | ) |
| explicit

Creates an instance of QCPLayout and sets default values. Note that since QCPLayout is an abstract base class, it can't be instantiated directly.

## Member Function Documentation

void QCPLayout::clear | ( |  | ) |

Removes and deletes all layout elements in this layout.

See also
  remove, removeAt

QCPLayoutElement * QCPLayout::elementAt | ( | int | index | ) | const
| pure virtual

Returns the element in the cell with the given index. If index is invalid, returns 0.

Note that even if index is valid, the respective cell may be empty in some layouts (e.g. QCPLayoutGrid), so this function may return 0 in those cases. You may use this function to check whether a cell is empty or not.

See also
  elements, elementCount, takeAt

Implemented in QCPLayoutInset, and QCPLayoutGrid.

int QCPLayout::elementCount | ( |  | ) | const
| pure virtual

Returns the number of elements/cells in the layout.

See also
  elements, elementAt

Implemented in QCPLayoutInset, and QCPLayoutGrid.

QList< QCPLayoutElement * > QCPLayout::elements | ( | bool | recursive | ) | const
| virtual

Returns a list of all child elements in this layout element. If recursive is true, all sub-child elements are included in the list, too.

Warning
  There may be entries with value 0 in the returned list. (For example, QCPLayoutGrid may have empty cells which yield 0 at the respective index.)

Reimplemented from QCPLayoutElement.

Reimplemented in QCPLayoutGrid.

bool QCPLayout::remove | ( | QCPLayoutElement * | element | ) |

Removes and deletes the provided element. Returns true on success. If element is not in the layout, returns false.

This function internally uses takeAt to remove the element from the layout and then deletes the element.

See also
  removeAt, take

bool QCPLayout::removeAt | ( | int | index | ) |

Removes and deletes the element at the provided index. Returns true on success. If index is invalid or points to an empty cell, returns false.

This function internally uses takeAt to remove the element from the layout and then deletes the returned element.

See also
  remove, takeAt

void QCPLayout::simplify | ( |  | ) |
| virtual

Simplifies the layout by collapsing empty cells. The exact behavior depends on subclasses, the default implementation does nothing.

Not all layouts need simplification. For example, QCPLayoutInset doesn't use explicit simplification while QCPLayoutGrid does.

Reimplemented in QCPLayoutInset, and QCPLayoutGrid.

void QCPLayout::sizeConstraintsChanged | ( |  | ) | const
| protected

Subclasses call this method to report changed (minimum/maximum) size constraints.

If the parent of this layout is again a QCPLayout, forwards the call to the parent's sizeConstraintsChanged. If the parent is a QWidget (i.e. is the QCustomPlot::plotLayout of QCustomPlot), calls QWidget::updateGeometry, so if the QCustomPlot widget is inside a Qt QLayout, it may update itself and resize cells accordingly.

bool QCPLayout::take | ( | QCPLayoutElement * | element | ) |
| pure virtual

Removes the specified element from the layout and returns true on success.

If the element isn't in this layout, returns false.

Note that some layouts don't remove the respective cell right away but leave an empty cell after successful removal of the layout element. To collapse empty cells, use simplify.

See also
  takeAt

Implemented in QCPLayoutInset, and QCPLayoutGrid.

QCPLayoutElement * QCPLayout::takeAt | ( | int | index | ) |
| pure virtual

Removes the element with the given index from the layout and returns it.

If the index is invalid or the cell with that index is empty, returns 0.

Note that some layouts don't remove the respective cell right away but leave an empty cell after successful removal of the layout element. To collapse empty cells, use simplify.

See also
  elementAt, take

Implemented in QCPLayoutInset, and QCPLayoutGrid.

void QCPLayout::update | ( | UpdatePhase | phase | ) |
| virtual

First calls the QCPLayoutElement::update base class implementation to update the margins on this layout.

Then calls updateLayout which subclasses reimplement to reposition and resize their cells.

Finally, update is called on all child elements.

Reimplemented from QCPLayoutElement.

The documentation for this class was generated from the following files:

- /home/wireshark/builders/wireshark-master/ubuntu-16.04-x64/build/ui/qt/widgets/qcustomplot.h
- /home/wireshark/builders/wireshark-master/ubuntu-16.04-x64/build/ui/qt/widgets/qcustomplot.cpp